/*  levelup.h: (c) 2002 sibn

    This file is part of GWiz.

    GWiz is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    GWiz is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GWiz; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HAVE_LEVELUP_H
#define HAVE_LEVELUP_H

typedef struct LevelUpEvent_ LevelUpEvent;

struct LevelUpEvent_ {
    gint hpinc;
    gchar *spell;
    gboolean str;
    gboolean iq;
    gboolean dev;
    gboolean vit;
    gboolean agi;
    gboolean lck;
    gboolean mage_spell;
    gint spell_candidates[5];
};

void HandleLevelUp (void);

gboolean CheckLvUpXP (void);

gboolean CheckLvUpExtendedXP (guint32 threshold, gint level);

void LvUpFig (void);

void LvUpMag (void);

void LvUpCle (void);

void LvUpThi (void);

void LvUpWiz (void);

void LvUpSam (void);

void LvUpLor (void);

void LvUpNin (void);

gboolean IncreaseStrength (void);

gboolean IncreaseIq (void);

gboolean IncreaseDevotion (void);

gboolean IncreaseVitality (void);

gboolean IncreaseAgility (void);

gboolean IncreaseLuck (void);

void SetAttrLimits (void);

DECINLINE gboolean CalculateAttrLuck (void);

void EnforceMPRestrictions (void);

void LearnNewSpell (void);

#endif /* HAVE_LEVELUP_H */
